# Create Components Dynamic Input Output

<Heading
  as={"h1"}
  className={"openapi__heading"}
  children={"Create Components Dynamic Input Output"}
>
</Heading>

<MethodEndpoint
  method={"post"}
  path={"/api/v1/haystack/components/input-output/generate"}
  context={"endpoint"}
>
  
</MethodEndpoint>

Returns updated input output schemas for Haystack components containing dynamic parameters.

Dynamic parameters are component input output parameters, which are postulated by component init params.

<Heading
  id={"request"}
  as={"h2"}
  className={"openapi-tabs__heading"}
  children={"Request"}
>
</Heading>

<ParamsDetails
  parameters={undefined}
>
  
</ParamsDetails>

<RequestSchema
  title={"Body"}
  body={{"content":{"application/json":{"schema":{"items":{"properties":{"component_init_timeout":{"anyOf":[{"type":"number"},{"type":"null"}],"description":"The time to wait (in seconds) for the component to start up when generating the input/output schema.","title":"Component Init Timeout"},"component_type":{"description":"Type of the component.","title":"Component Type","type":"string"},"init_params":{"additionalProperties":true,"description":"Component init params as key-value pairs of param name and value.","title":"Init Params","type":"object"}},"required":["component_type","init_params"],"title":"HaystackComponentInputOutputGenerationParams","type":"object"},"title":"Component Params","type":"array"}}},"required":true}}
>
  
</RequestSchema>

<StatusCodes
  id={undefined}
  label={undefined}
  responses={{"200":{"content":{"application/json":{"schema":{"items":{"properties":{"errors":{"anyOf":[{"items":{"description":"Describes errors caused by invalid haystack components.","properties":{"code":{"description":"Error code","title":"Code","type":"string"},"message":{"description":"Error message","title":"Message","type":"string"},"title":{"description":"Error title","title":"Title","type":"string"}},"required":["code","message","title"],"title":"HaystackComponentInputOutputError","type":"object"},"type":"array"},{"type":"null"}],"description":"Errors encountered during the generation of input/output schemas","title":"Errors during input/output schema generation"},"init_parameters":{"anyOf":[{"additionalProperties":true,"type":"object"},{"type":"null"}],"description":"Additional dynamic parameters of the component that are not part of the component schema but are relevant for the component usage (e.g. Code component).","title":"Component init parameters"},"input":{"additionalProperties":true,"description":"Input schema of the component","title":"Input schema of the component","type":"object"},"name":{"description":"Schema for all available haystack components.","title":"Haystack Component Input Output Schema","type":"string"},"output":{"additionalProperties":true,"description":"Output schema of the component","title":"Output schema of the component","type":"object"}},"required":["name","input","output"],"title":"HaystackComponentInputOutputSchema","type":"object"},"title":"Response 200 Create Components Dynamic Input Output Api V1 Haystack Components Input Output Generate Post","type":"array"}}},"description":"Generated dynamic input output component schemas."},"400":{"description":"Failed to generate dynamic input output schemas."},"422":{"content":{"application/json":{"schema":{"properties":{"detail":{"items":{"properties":{"ctx":{"title":"Context","type":"object"},"input":{"title":"Input"},"loc":{"items":{"anyOf":[{"type":"string"},{"type":"integer"}]},"title":"Location","type":"array"},"msg":{"title":"Message","type":"string"},"type":{"title":"Error Type","type":"string"}},"required":["loc","msg","type"],"title":"ValidationError","type":"object"},"title":"Detail","type":"array"}},"title":"HTTPValidationError","type":"object"}}},"description":"Validation Error"}}}
>
  
</StatusCodes>
